

//********variables*******
pi=3.14159;

triangle_length_a=40;//9.7;
triangle_length_b=40;//9.7;

wall_t=1;

triangle_base_length=triangle_length_a;
triangle_matched_sides_length=triangle_length_b;
triangle_apex_angle=2*asin((triangle_base_length/2)/triangle_matched_sides_length);//sin relationship to get angle side_length/sin90=half_base_length/sin(half apex angle)

number_of_triangles=5;
angle_tilt=53;//currently empirically determined, but can determine this from the triangles used (base, height, count)
angle_twist=360/number_of_triangles;//determined from number of triangles used (360/number_of_triangles)

shape_perimeter=number_of_triangles*triangle_base_length;

circumscribed_radius=sin((180-angle_twist)/2)*triangle_base_length/sin(angle_twist);//use sin relationship i.e. Sina/A=sinb/B => unknown edge (radius)= sin (b)*flat_end_length/sin(72)

cicumscribed_perimeter=pi*2*circumscribed_radius;

angle_tilt2=90-asin(circumscribed_radius/triangle_matched_sides_length);//inverse sin relationship to get angle along mating triangle sides

triangle_centerline_length=(triangle_base_length/2)/tan(triangle_apex_angle/2);//30 as half 60, as equilateral triangle
projected_triangle_centerline_length=(triangle_length_a/2)/tan(angle_twist/2);

angle_tilt3=acos(projected_triangle_centerline_length/triangle_centerline_length);//need angle along centrelines, use acos (projected/actual centreline lengths)

color_array=["Red","Orange","Yellow","Green","Blue","Indigo","Violet","Black","White"];

scaling_factor=1.138;//1.042 for 9.7base,12side with 9 triangles; 1.138 for 9.7base&side with 5 triangles

scaling_factor=1+sin(angle_tilt/2)/3;//work it out mathematically...not perfect but close...perhaps close enough

//************check*********
echo ("flat perimeter",shape_perimeter);
echo ("circular perimeter",cicumscribed_perimeter);
echo ("circumscribed_radius",circumscribed_radius);
echo ("triangle_centerline_length",triangle_centerline_length);
echo ("projected_triangle_centerline_length",projected_triangle_centerline_length);
echo ("angle_tilt3",angle_tilt3);
echo ("triangle_apex_angle",triangle_apex_angle);

//*********calls****
for(i=[0:number_of_triangles-1]){//loop creating the shape from triangles
//	color(color_array[i])rotate(a=[0,0,(i)*60])triangle_b();//angle_tilt3,0,angle_twist
	color(color_array[i])rotate(a=[0,0,(i)*60])triangle_a();
}
//rotate(a=[0,0,0])translate(v=[])cylinder(r=circumscribed_radius,h=0.9,center=false);//this disc show the circumscribed circle
//rotate(a=[angle_tilt2,0,angle_twist/2])translate(v=[])cylinder(r=circumscribed_radius,h=0.9,center=false);//this disc show the circumscribed circle angled along a meeting edge
//rotate(a=[angle_tilt3,0,0])translate(v=[])cylinder(r=circumscribed_radius,h=0.9,center=false);//this disc show the circumscribed circle angle along a centreline
//color("Red")rotate(a=[angle_tilt,0,0*angle_twist])triangle_a();
//color("Orange")rotate(a=[angle_tilt,0,1*angle_twist])triangle_a();
//color("Yellow")rotate(a=[angle_tilt,0,2*angle_twist])triangle_a();
//color("Green")rotate(a=[angle_tilt,0,3*angle_twist])triangle_a();
//color("Blue")rotate(a=[angle_tilt,0,4*angle_twist])triangle_a();
//color("Indigo")rotate(a=[angle_tilt,0,5*angle_twist])triangle_a();

//**********modules*******

module triangle_a(){
	translate(v=[0,-0.2,0])linear_extrude(height=1)isosceles_triangle_b_h(triangle_base_length,sin(acos((triangle_base_length/2)/triangle_matched_sides_length))*triangle_matched_sides_length,center=2);
}

module triangle_b(){
	translate(v=[0,-2*triangle_centerline_length/3]) hull(){
		linear_extrude(height=1)isosceles_triangle_b_h(triangle_base_length,triangle_centerline_length,center=1);
		translate(v=[0,0,1])linear_extrude(height=0.1)isosceles_triangle_b_h(scaling_factor*triangle_base_length,scaling_factor*triangle_centerline_length,center=1);
	}
}

module ellipse(ellipse_r, ellipse_R){
	scale(v=[1,ellipse_R/ellipse_r])circle(r=ellipse_r,center=true);

}

module isosceles_triangle_b_h(tri_base,tri_height,center=0){
	//center=0 implies first vertex at 0,0 base along +x_axis, tip up
	if (center==0) polygon(points=[[0,0],[tri_base/2,tri_height],[tri_base,0]]);
	//center=1 implies centroid at 0,0 with tip up
	if (center==1) translate(v=[-tri_base/2,-tri_height/3]) polygon(points=[[0,0],[tri_base/2,tri_height],[tri_base,0]]);
	//center=2 implies tip at 0,0 with tip up
	if (center==2) translate(v=[-tri_base/2,-tri_height]) polygon(points=[[0,0],[tri_base/2,tri_height],[tri_base,0]]);
}