

//*******user*variables*******
pi=3.14159;//don't really need this to be accurate as it's just for some of the echo output

triangle_length_a=80;//92.7 is the actual size for a 30cm diameter dome
triangle_length_b=125.0;//82mm is the actual size for a 30cm diameter dome

rim_t=3;//how thick the plastic making up the rim around the edge of the triangle is
rim_w=3;//how wide the rim around the edge of the triangle is
centre_t=1;//how thick the plastic making up the middle of the triangle is

number_of_triangles=9;//how many triangles will this be assembled with, this number determines the angle of slope of the triangle rim (Dean's dome is based on pentagons so 5 should be used iy want to copy)

just_a_triangle=0;//if set to 0 will give you all the triangles to make you n-gon based pyramid else if set to 1 it will give you just one of them
has_mouse_ears=1;//if set to 1 you will get mouse ears... else set to 0 so you wont!
is_folded=1;//if you ask for all the parts setting this to 1 will show you how they look folded, wont work with mouse ears though!

z_layer_thickness=0.32;//how thick in the z direction are the printers layers?

mouse_ear_thickness=2*z_layer_thickness;//how thick do you want your mouse ears? 2 layers is good!
mouse_ear_radius=5;//the radius of your mouse ears

//********calculated*variables*******

triangle_base_length=triangle_length_a;
triangle_matched_sides_length=triangle_length_b;
triangle_apex_angle=2*asin((triangle_base_length/2)/triangle_matched_sides_length);//sin relationship to get angle side_length/sin90=half_base_length/sin(half apex angle)

angle_twist=360/number_of_triangles;//determined from number of triangles used (360/number_of_triangles)

shape_perimeter=number_of_triangles*triangle_base_length;

circumscribed_radius=sin((180-angle_twist)/2)*triangle_base_length/sin(angle_twist);//use sin relationship i.e. Sina/A=sinb/B => unknown edge (radius)= sin (b)*flat_end_length/sin(72)

circumscribed_perimeter=pi*2*circumscribed_radius;

angle_tilt2=90-asin(circumscribed_radius/triangle_matched_sides_length);//inverse sin relationship to get angle along mating triangle sides

triangle_centerline_length=(triangle_base_length/2)/tan(triangle_apex_angle/2);//30 as half 60, as equilateral triangle
projected_triangle_centerline_length=(triangle_length_a/2)/tan(angle_twist/2);

angle_tilt3=acos(projected_triangle_centerline_length/triangle_centerline_length);//need angle along centrelines, use acos (projected/actual centreline lengths)

color_array=["Red","Orange","Yellow","Green","Blue","Indigo","Violet","Black","White"];

extra_height=rim_t/cos(angle_tilt3);
extra_tip_l=rim_t*tan(angle_tilt3);
scaling_factor=((2*triangle_centerline_length/3)+extra_tip_l)/(2*triangle_centerline_length/3);

cutout_triangle_centerline_length=triangle_centerline_length-rim_w-rim_w/tan(triangle_apex_angle/2);
cutout_triangle_base_length=2*tan(triangle_apex_angle/2)*cutout_triangle_centerline_length;

//***********debug*check*********

echo ("flat perimeter",shape_perimeter);
echo ("circular perimeter",circumscribed_perimeter);
echo ("circumscribed_radius",circumscribed_radius);
echo ("triangle_centerline_length",triangle_centerline_length);
echo ("projected_triangle_centerline_length",projected_triangle_centerline_length);
echo ("angle_tilt3",angle_tilt3);
echo ("triangle_apex_angle",triangle_apex_angle);
echo ("scaling_factor",scaling_factor);
echo ("extra_height",extra_height);

//*********calls****

if(just_a_triangle==0)mirror(v=[0,0,1]){
	for(i=[0:number_of_triangles-1]){//loop creating the shape from triangles

		if(is_folded==1){
			color(color_array[i])rotate(a=[angle_tilt3,0,i*angle_twist])translate(v=[0,-2/3*triangle_centerline_length*scaling_factor,-extra_height]){//comment in this line and comment out the line below for folded pyramidal view view and vice-versa for flat view
				difference(){
					triangle_b();//main triangle shape
					translate(v=[0,0,-centre_t])mirror(v=[0,0,0])linear_extrude(height=rim_t)isosceles_triangle_b_h(cutout_triangle_base_length,cutout_triangle_centerline_length,center=1);//internal triangle shaped cutout
				}
			}
		}

		if(is_folded==0){
			color(color_array[i])rotate(a=[0,0,i*triangle_apex_angle])translate(v=[0,-2/3*triangle_centerline_length*scaling_factor,-extra_height]){
				difference(){
					triangle_b();//main triangle shape
					translate(v=[0,0,-centre_t])mirror(v=[0,0,0])linear_extrude(height=rim_t)isosceles_triangle_b_h(cutout_triangle_base_length,cutout_triangle_centerline_length,center=1);//internal triangle shaped cutout
				}
			}
		}
	}
}


if(has_mouse_ears==1 && just_a_triangle==0 && is_folded==0){//mouse ear cylinders go here
	for(i=[0:number_of_triangles]){
		rotate(a=[0,0,i*triangle_apex_angle])translate(v=[-triangle_base_length*scaling_factor/2,-triangle_centerline_length*scaling_factor,mouse_ear_thickness/2]) cylinder(r=mouse_ear_radius,h=mouse_ear_thickness,center=true);//mouse ear at bottom left of triangle
	}
}


if(just_a_triangle==1){
	union(){
		translate(v=[0,0,rim_t])mirror(v=[0,0,1])difference(){
			triangle_b();//main triangle shape
			translate(v=[0,0,-centre_t])mirror(v=[0,0,0])linear_extrude(height=rim_t)isosceles_triangle_b_h(cutout_triangle_base_length,cutout_triangle_centerline_length,center=1);//internal triangle shaped cutout
		}
		if(has_mouse_ears==1){//mouse ear cylinders go here
			translate(v=[0,2/3*triangle_centerline_length,mouse_ear_thickness/2]) cylinder(r=mouse_ear_radius,h=mouse_ear_thickness,center=true);//mouse ear at tip of triangle
			translate(v=[-triangle_base_length/2,-1/3*triangle_centerline_length,mouse_ear_thickness/2]) cylinder(r=mouse_ear_radius,h=mouse_ear_thickness,center=true);//mouse ear at bottom left of triangle
			translate(v=[triangle_base_length/2,-1/3*triangle_centerline_length,mouse_ear_thickness/2]) cylinder(r=mouse_ear_radius,h=mouse_ear_thickness,center=true);//mouse ear at bottom right of triangle
		}
	}
}


//**********modules*******

module triangle_a(){
	translate(v=[0,-0.2,0])linear_extrude(height=1)isosceles_triangle_b_h(triangle_base_length,sin(acos((triangle_base_length/2)/triangle_matched_sides_length))*triangle_matched_sides_length,center=2);
}

module triangle_b(){
	translate(v=[0,0]) hull(){
		linear_extrude(height=0.1) isosceles_triangle_b_h(triangle_base_length,triangle_centerline_length,center=1);
		translate(v=[0,0,rim_t]) mirror(v=[0,0,1])linear_extrude(height=0.1)isosceles_triangle_b_h(scaling_factor*triangle_base_length,scaling_factor*triangle_centerline_length,center=1);
	}
}

module ellipse(ellipse_r, ellipse_R){
	scale(v=[1,ellipse_R/ellipse_r])circle(r=ellipse_r,center=true);

}

module isosceles_triangle_b_h(tri_base,tri_height,center=0){
	//center=0 implies first vertex at 0,0 base along +x_axis, tip up
	if (center==0) polygon(points=[[0,0],[tri_base/2,tri_height],[tri_base,0]]);
	//center=1 implies centroid at 0,0 with tip up
	if (center==1) translate(v=[-tri_base/2,-tri_height/3]) polygon(points=[[0,0],[tri_base/2,tri_height],[tri_base,0]]);
	//center=2 implies tip at 0,0 with tip up
	if (center==2) translate(v=[-tri_base/2,-tri_height]) polygon(points=[[0,0],[tri_base/2,tri_height],[tri_base,0]]);
}